#!/usr/bin/env python
# -*- coding: utf-8 -*-
# postserver.py
# Spécial sample powerded by Bud 'Robert' Spencer
# launch cmd : python postserver

from time import sleep
import threading;import subprocess;import signal;import sys
import RPi.GPIO as GPIO

GPIO.setmode(GPIO.BCM);GPIO.setwarnings(False)
GPIO.setup(4,GPIO.IN,pull_up_down=GPIO.PUD_UP)
GPIO.setup(17,GPIO.IN,pull_up_down=GPIO.PUD_UP)
GPIO.setup(27,GPIO.IN,pull_up_down=GPIO.PUD_UP)
GPIO.setup(22,GPIO.IN,pull_up_down=GPIO.PUD_UP)
GPIO.setup(18,GPIO.OUT)

bt0 = ['4',0,0];bt1 = ['17',0,0];
bt2 = ['27',0,0];bt3 = ['22',0,0]
bts = [bt0,bt1,bt2,bt3]

def send(gpio,mode):
	subprocess.Popen(['python','postclient.py',
	str(gpio),str(mode)], stdout=0)
	
def getGPIO(timing):
	try:
		threading.Timer(timing,getGPIO,[timing]).start()
		i = 0
		bt0[1] = GPIO.input(4);bt1[1] = GPIO.input(17)
		bt2[1] = GPIO.input(27);bt3[1] = GPIO.input(22)
		for bt in bts:
			if bt[1]==0:bt[2]+=1;i = 1
			else:
				if bt[2] > 0:send(bt[0],bt[2])
				bt[2] = 0 
			GPIO.output(18,i)
	except RuntimeError:
		pass
				
def signal_hndl(signal,f):
	print ('\nBud Spencer as free')
	sleep(2);GPIO.cleanup();sys.exit(0)	
		
def main():
	print ('Bud Spencer as PostMaster')
	signal.signal(signal.SIGINT,signal_hndl)		
	getGPIO(0.1)
	return 0

if __name__ == '__main__':
	main()

